/*
 * (c) Copyright 1993, Silicon Graphics, Inc.
 *               1993-1995 Microsoft Corporation
 *
 * ALL RIGHTS RESERVED
 *
 * Please refer to OpenGL/readme.txt for additional information
 *
 */

/*
 *  light.c
 *  This program demonstrates the use of the OpenGL lighting 
 *  model.  A sphere is drawn using a grey material characteristic. 
 *  A single light source illuminates the object.
 */
#define  __LIGHT__

#include <windows.h>
#include <math.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
GLfloat  ambientLight2[] = { 0.2f, 0.2f, 0.2f, 1.0f };
GLfloat  diffuseLight2[] = { 0.6f, 0.6f, 0.6f, 1.0f };
GLfloat  specular2[] = { 1.0f, 1.0f, 1.0f, 1.0f};
GLfloat	 lightPos2[] = { -60.0f, 25.0f, 50.0f, 1.0f };

/*  Initialize material property, light source, lighting model,
 *  and depth buffer.
 */
void myinit(void)
{
    GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
    GLfloat mat_shininess[] = { 50.0 };
    GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };

	GLfloat matAmbDiff1[4] = { 1.0f, 0.0f, 1.00f, 1.0f };
    GLfloat matAmbDiff2[4] = { 1.0f, 0.0f, 0.00f, 1.0f };

    glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
    glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, matAmbDiff1);


	glLightfv(GL_LIGHT0,GL_AMBIENT,ambientLight2);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuseLight2);
	glLightfv(GL_LIGHT0,GL_SPECULAR,specular2);
glLightfv(GL_LIGHT0, GL_POSITION, lightPos2);
    //glLightfv(GL_LIGHT0, GL_POSITION, light_position);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glDepthFunc(GL_LESS);
    glEnable(GL_DEPTH_TEST);
}

void display(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    auxSolidSphere(1.0);
    glFlush();
}

void myReshape(GLsizei w, GLsizei h)
{
    h = (h == 0) ? 1 : h;
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (w <= h) 
    glOrtho (-1.5, 1.5, -1.5*(GLfloat)h/(GLfloat)w, 
        1.5*(GLfloat)h/(GLfloat)w, -10.0, 10.0);
    else 
    glOrtho (-1.5*(GLfloat)w/(GLfloat)h, 
        1.5*(GLfloat)w/(GLfloat)h, -1.5, 1.5, -10.0, 10.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

/*  Main Loop
 *  Open window with initial window size, title bar, 
 *  RGBA display mode, and handle input events.
 */
/*
int main(int argc, char** argv)
{
    auxInitDisplayMode (AUX_SINGLE | AUX_RGB | AUX_DEPTH16);
    auxInitPosition (0, 0, 500, 500);
    auxInitWindow ("Lighting");
    myinit();
    auxReshapeFunc (myReshape);
    auxMainLoop(display);
    return(0);
}
*/