// MfcGlView.cpp : implementation of the CMfcGlView class
//

#include "stdafx.h"
#include "MfcGl.h"

#include "MfcGlDoc.h"
#include "MfcGlView.h"

//INMA MICODIGO

#include "glcode.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//MICODIGO

unsigned char threeto8[8] = 
{
	0, 0111>>1, 0222>>1, 0333>>1, 0444>>1, 0555>>1, 0666>>1, 0377
};

unsigned char twoto8[4] = 
{
	0, 0x55, 0xaa, 0xff
};

unsigned char oneto8[2] = 
{
	0, 255
};

static int defaultOverride[13] = 
{
	0, 3, 24, 27, 64, 67, 88, 173, 181, 236, 247, 164, 91
};

static PALETTEENTRY defaultPalEntry[20] = 
{
	{ 0,   0,   0,    0 },
	{ 0x80,0,   0,    0 },
	{ 0,   0x80,0,    0 },
	{ 0x80,0x80,0,    0 },
	{ 0,   0,   0x80, 0 },
	{ 0x80,0,   0x80, 0 },
	{ 0,   0x80,0x80, 0 },
	{ 0xC0,0xC0,0xC0, 0 },

	{ 192, 220, 192,  0 },
	{ 166, 202, 240,  0 },
	{ 255, 251, 240,  0 },
	{ 160, 160, 164,  0 },

	{ 0x80,0x80,0x80, 0 },
	{ 0xFF,0,   0,    0 },
	{ 0,   0xFF,0,    0 },
	{ 0xFF,0xFF,0,    0 },
	{ 0,   0,   0xFF, 0 },
	{ 0xFF,0,   0xFF, 0 },
	{ 0,   0xFF,0xFF, 0 },
	{ 0xFF,0xFF,0xFF, 0 }
};

//FIN MICODIGO
/////////////////////////////////////////////////////////////////////////////
// CMfcGlView

IMPLEMENT_DYNCREATE(CMfcGlView, CView)

BEGIN_MESSAGE_MAP(CMfcGlView, CView)
	//{{AFX_MSG_MAP(CMfcGlView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcGlView construction/destruction

CMfcGlView::CMfcGlView()
{
	// TODO: add construction code here
   m_pDC=NULL;
}

CMfcGlView::~CMfcGlView()
{
}

BOOL CMfcGlView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	//INMA:anyadimos los estilos de ventana que requiere OPENGL antes
	//de crear la ventana
	//CSOWNDC sirve para que la ventana pueda tener su propio contexto de 
	//dispositivo privado
	cs.style|=(WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CS_OWNDC);


	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMfcGlView drawing

void CMfcGlView::OnDraw(CDC* pDC)
{
	CMfcGlDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	
	//MICODIGO
	HDC m_hDC=pDC->GetSafeHdc();
	//Activa el contexto de generacion
	wglMakeCurrent(m_hDC,m_hRC);
	//Llama al codigo OPENGL externo
	GLRenderScene(NULL);
	//Intercambia la escena al frente
	SwapBuffers(m_hDC);
	//Permite coexistencia de otros contextos de generacion
	wglMakeCurrent(m_hDC,NULL);


}

/////////////////////////////////////////////////////////////////////////////
// CMfcGlView diagnostics

#ifdef _DEBUG
void CMfcGlView::AssertValid() const
{
	CView::AssertValid();
}

void CMfcGlView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMfcGlDoc* CMfcGlView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMfcGlDoc)));
	return (CMfcGlDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMfcGlView message handlers

//INMA: nuevos mensajes anyadidos con el ClassWizard, para poder
//actuar frente a los eventos de creacion y destruccion de ventana

//Dentro de OnCreate establecemos el formato de pixel
int CMfcGlView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	//MICODIGO
	int nPixelFormat;			//Indice del formato de pixel

	m_pDC = new CClientDC(this);
	HDC m_hDC=m_pDC->GetSafeHdc();

	static PIXELFORMATDESCRIPTOR pfd={
		sizeof(PIXELFORMATDESCRIPTOR),	//Tamanyo de esta estructura
		1,								//Version de esta estructura
		PFD_DRAW_TO_WINDOW|			//Dibuja en la ventana(no en un mapa)
		PFD_SUPPORT_OPENGL|			//Soporte de llamada OPENGL en la ventana
		PFD_DOUBLEBUFFER,			//Modo de doble buffer
		PFD_TYPE_RGBA,				//Modo de color RGBA
		24,							//Color de 24 bits
		0,0,0,0,0,0,
		0,0,
		0,0,0,0,0,
		32,							//Tamao del buffer de profundidad
		0,
		0,
		PFD_MAIN_PLANE,				//Dibuja en el plano principal
		0,							
		0,0,0};
	//Elegimos el formato de pixel que mejor encaje con el descrito en pfd
	if ( (nPixelFormat = ChoosePixelFormat(m_pDC->GetSafeHdc(), &pfd)) == 0 )
    {
        MessageBox("ChoosePixelFormat failed");
        return FALSE;
    }

	//Activamos el formato de pixel para el contexto de dispositivo
	if (SetPixelFormat(m_pDC->GetSafeHdc(), nPixelFormat, &pfd) == FALSE)
    {
        MessageBox("SetPixelFormat failed");
        return FALSE;
    }
	
	//Creamos el contexto de generacion
	m_hRC=wglCreateContext(m_hDC);

	//Activamos el contexto de generacion y ejecutamos la inicializacion
	wglMakeCurrent(m_hDC,m_hRC);
	GLSetupRC(m_hDC);

   


	//FIN MI CODIGO

	return 0;
}
//MICODIGO
//Destruccion de la ventana, borramos el contexto de generacion y liberamos
//el contexto de dispositivo
void CMfcGlView::OnDestroy() 
{

	wglDeleteContext(m_hRC);
//	ReleaseDC(m_pDC->GetSafeHdc());
if (m_pDC)
        delete m_pDC;
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	
}
/************************************************
Funcion que responde al evento de cambio de tamao
de la ventana.
****************************************************/
void CMfcGlView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	//MICODIGO
	VERIFY(wglMakeCurrent(m_pDC->GetSafeHdc(),m_hRC));
	GLResize(cx,cy);
	VERIFY(wglMakeCurrent(NULL,NULL));

//	RedrawWindow(); Lo quito de momento
//	InvalidateRect(NULL,TRUE);
	
}
//Sobrecargamos para evitar la limpieza del fondo
//cada vez que redibujemos la ventana
BOOL CMfcGlView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
//	return CView::OnEraseBkgnd(pDC);
	return FALSE;
}

//Inicializa el objeto CPallete
void CMfcGlView::InitializePallete()
{
PIXELFORMATDESCRIPTOR pfd;//Descriptor del formato de pixel
LOGPALETTE *pPal;//Puntero a la paleta lgica
int nPixelFormat; //Indice del formato de pizel
int  i;
int nColors; //Numero de entradas en la paleta
 
    //Coge el ndice del formato de pxel y recupera la descripcin
	//del formato de pxel
    nPixelFormat = ::GetPixelFormat(m_pDC->GetSafeHdc());
    ::DescribePixelFormat(m_pDC->GetSafeHdc(), nPixelFormat, sizeof(pfd), &pfd);

    if (pfd.dwFlags & PFD_NEED_PALETTE)
    {
		//Numero de entradas en la paleta. 8 bits proporcionan 256 entradas
        nColors = 1 << pfd.cColorBits;

		//Reserva espacio para la estructra de la paleta lgica ms todas
		//las entradas de la paleta
        pPal = (PLOGPALETTE) new char[sizeof(LOGPALETTE) + nPixelFormat * sizeof(PALETTEENTRY)];

        ASSERT(pPal != NULL);

		//Rellena la cabecera de la paleta
        pPal->palVersion = 0x300;
        pPal->palNumEntries = nColors;

		//Bucle a travs de todas las entradas de la paleta
        for (i=0; i<nColors; i++)
        {
            pPal->palPalEntry[i].peRed =
                    ComponentFromIndex(i, pfd.cRedBits, pfd.cRedShift);
            pPal->palPalEntry[i].peGreen =
                    ComponentFromIndex(i, pfd.cGreenBits, pfd.cGreenShift);
            pPal->palPalEntry[i].peBlue =
                    ComponentFromIndex(i, pfd.cBlueBits, pfd.cBlueShift);
            pPal->palPalEntry[i].peFlags = 0;
        }

        /* fix up the palette to include the default GDI palette */
        if ((pfd.cColorBits == 8)                           &&
            (pfd.cRedBits   == 3) && (pfd.cRedShift   == 0) &&
            (pfd.cGreenBits == 3) && (pfd.cGreenShift == 3) &&
            (pfd.cBlueBits  == 2) && (pfd.cBlueShift  == 6)
           )
        {
			for (i = 1 ; i <= 12 ; i++)
                 pPal->palPalEntry[defaultOverride[i]] = defaultPalEntry[i];
        }

		//Crea la paleta
        m_GLPalette.CreatePalette(pPal);
        delete pPal;

      //  m_pOldPalette = m_pDC->SelectPalette(&m_cPalette, FALSE);
		m_pDC->SelectPalette(&m_GLPalette, FALSE);
        m_pDC->RealizePalette();
    }
	free(pPal);
}


unsigned char CMfcGlView::ComponentFromIndex(int i, UINT nbits, UINT shift)
{
  unsigned char val;

    val = (unsigned char) (i >> shift);
    switch (nbits) 
	{

    case 1:
        val &= 0x1;
        return oneto8[val];
    case 2:
        val &= 0x3;
        return twoto8[val];
    case 3:
        val &= 0x7;
        return threeto8[val];

    default:
        return 0;
    }
}
