// glcode.h
// Declarations for external OpenGL module.  These functions are
// defined in glcode.c and are called appropriately by the CView
// derived classes.
//#ifndef __GLCODE__
//#define __GLCODE__
#ifdef _GLCODE_
	//VARIABLES GLOBALES

	float posx=0;
	float posy=0;
	float posz=-2;//Posicion punto de vista

	//Punto de vista para utilizar glulookat:
	float eyex=0,eyey=0,eyez=2;
	float centx=0,centy=0,centz=0;
	float radio=2;
	float angh=3.1415f/2.0f, angv=3.1415f/2.0f;

	float pnear=0.1f;
	float pfar=5.0;//Posicion plano near y far
	int wide=0;
	int height=0;
	
	char mode_act=0;
	int objeto=0;//OBJETO QUE DIBUJAMOS
	int mode_vis=0;//Rejilla o relleno
	
	int material =0;
	GLfloat matYell[4] = { 1.0f, 1.0f, 0.00f, 1.0f };
    GLfloat matBlue[4] = { 0.0f, 0.0f, 1.00f, 1.0f };
	GLfloat matGreen[4] = { 0.0f, 1.0f, 0.00f, 1.0f };
	//Variables para la animacion
	char animacionActivada=0;
	double rotationx = 0.0,rotationy = 0.0;		/*Angulo que tiene el cilindro en cada momento*/



	//PROTOTIPOS FUNCIONES
	void inicializacion_gl(void);
	void redibujar_escena(void);
	void cambia_tamanyo(int w, int h);
	static void dibuja_cilindro(void);
	void GLPosView(float dx, float dy, float dz);

#else
	
	extern char mode_act;
	extern int objeto;
	extern int mode_vis;
	extern int material;
	extern double rotationx,rotationy;
	extern int wide, height;
	extern char animacionActivada;

	extern void inicializacion_gl(void);
	extern void cambia_tamanyo(int anchura, int altura);
	extern void eventos_teclado(unsigned char key);
	extern void redibujar_escena(void);
	extern void actualizar_CB(void);

	extern void GLPosView(float dx, float dy, float dz);



#endif//ifdef_GLCODE_




