// glcode.c MICODIGO
//Modulo en el que incluiremos nuestro codigo C de OpenGL.
#define _GLCODE_
#include <windows.h>
#include <math.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include "glcode.h"


// Easier way to specify color for Windows bigots
#define glRGB(x, y, z)	glColor3ub((GLubyte)x, (GLubyte)y, (GLubyte)z)
#define PI 3.1416

// Componente de la iluminacion
GLfloat  ambientLight[] = { 0.2f, 0.2f, 0.2f, 1.0f };
GLfloat  diffuseLight[] = { 0.6f, 0.6f, 0.6f, 1.0f };
GLfloat  specular[] = { 1.0f, 1.0f, 1.0f, 1.0f};
GLfloat	 lightPos[] = { -60.0f, 25.0f, 50.0f, 1.0f };

double lastTime = 0.0;		/*Tiempo en el que se dibujo el fotograma anterior*/
double rotationRate = 360.0 / 8.0;	/*Velocidad de rotacion del cilindro*/
double rotation = 0.0;		/*Angulo que tiene el cilindro en cada momento*/
char animacionActivada = FALSE; /*Activar o desactivar giro de la ventana*/

/****************************************************************
Funcion en la que inicializamos el contexto de dispositivo:
activamos el color de fondo, iluminaciones o calculos preliminares
Parametros: puntero void que nos permitira pasar cualquier tipo
de datos
Return:nada
// Do any initialization of the rendering context here, such as
// setting background colors, setting up lighting, or performing
// preliminary calculations
***************************************************************/
void GLSetupRC(void *pData)
{

	glEnable(GL_DEPTH_TEST);	//Elimina las superficies ocultas
	glEnable(GL_COLOR_MATERIAL);

	glClearColor(0.0f, 0.0f, 0.0f, 1.0f ); //Elige el color de fondo de la ventana

	//Activamos y definimos luces
	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0,GL_AMBIENT,ambientLight);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuseLight);
	glLightfv(GL_LIGHT0,GL_SPECULAR,specular);
	glLightfv(GL_LIGHT0,GL_POSITION,lightPos);
	 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glEnable(GL_LIGHT0);


	/* glEnable(GL_CULL_FACE); //INMA ACTIVAR CULLING: PARA QUE SOLO DIBUJE UNA CARA
    glCullFace(GL_FRONT);// Por defecto el front*/
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); //Modo de dibujo de los poligonos:
						//cara externa e interna con lineas
   /*  glPolygonMode(GL_FRONT, GL_LINE); //Una cara con lineas y otra rellena
	glPolygonMode(GL_BACK, GL_FILL); */





	//Definimos materiales
/*	glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
	glMaterialfv(GL_FRONT, GL_SPECULAR,specular);
	glMateriali(GL_FRONT,GL_SHININESS,100);

	// Color de texto 3D
	glRGB(0, 0, 255);

	hDC = (HDC)pData;
	hFont = CreateFontIndirect(&logfont);
	SelectObject (hDC, hFont); 

	
	//create display lists for glyphs 0 through 255 with 0.1 extrusion 
	// and default deviation. The display list numbering starts at 1000 
	// (it could be any number). 
	wglUseFontOutlines(hDC, 0, 255, 1000, 0.0f, 0.3f, 
				WGL_FONT_POLYGONS, agmf); 

	DeleteObject(hFont);*/
 }


/***************************************************************
Funcion que calcula el volumen el volumen de visualizacion y la
informacion de la vista. La llamaremos desde el mensaje WM_SIZE
Parmetros:ancho y alto de la ventana
******************************************************************/
// Called by Windows when it receives the WM_SIZE message.
// Put any code needed here to recalc the viewing volume and
// viewport info
void GLResize(GLsizei w, GLsizei h)
{
	GLfloat nRange = 120.0f;

	// Prevent a divide by zero
	if(h == 0)
		h = 1;

		/*DEFINIMOS CARACTERICAS DE DONDE ESTA Y COMO VE EL OBSERVADOR*/
	/*Definimos el area de dibujo (Viewport) dentro de la ventana (en este caso
	le decimos que el area es toda la ventan*/


	  /*INMA:PROBAR A DIBUJAR DOS COSAS EN EL VIEWPORT: poner todo 
     * el codigo de arriba otra vez,  cambiando el viewport por la mitad
     * de la escena glViewport(ancho/2, 0, ancho/, alto);
     * y eliminando del segundo trozo los glClear,  y cambiado el aspecto
     * en gluperspective
     */

/*Definimosla proyeccion: perspectiva:como se proyectan los datos de los objetos
	sobre nuestra ventana 2D*/
	// Set Viewport to window dimensions
    glViewport(0, 0, w, h);//INMA: PROBAR A CAMBIAR ESTO: hacerlo mayor y menos
							//que la ventana

	glMatrixMode(GL_PROJECTION);

	// Reset coordinate system
	glLoadIdentity();/*Empezamos con matriz identidad:no hay perspectiva*/

	// Establish clipping volume (left, right, bottom, top, near, far)
   /* if (w <= h) 
		glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, -nRange, nRange);
    else 
		glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, -nRange, nRange);*/


	  //gluPerspective(60.0, (float)w/h, .1, 5.0); //Ponemos matriz de perspectiva
	gluPerspective(60.0, (float)w/h, 0.1, 5.0); //Ponemos matriz de perspectiva
		//  60: angulo de vision
		//  ancho/alto: aspecto. Si queremos que los objetos no se distorsionen
		//	cuando la ventana es mas ancha hay que cambiar el aspecto segun
		//	las proporciones de la ventana.
		//  0.1:distancia cercana (a menor distancia de 0.1 no se dibuja nada
		//  5.0 : distancia lejana ( a mayor distanciano se dibuja nada
    //glFrustum(-2, 2, -1, 1, 1, 3);  // ancho, alto, prof 


	// Set up transformation to draw the string. 
//	glTranslatef(-35.0f, 0.0f, -5.0f) ;
//	glScalef(60.0f, 60.0f, 60.0f); 

	/*Inicializa posicion del punto de vista*/
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
    glTranslatef(0, 0, -2); /*INMA TRASLADAR EL PUNTO DE VISTA. Si lo 
			    alejamos demasiado y el plano far esta cerca no 
			    se vera nada. Probar a ponerlo en 5 y ver como se corta 
			    el objeto*/

}



//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
// Render your OpenGL Scene here.
void GLRenderScene(void *pData)
{



	/*Giramos el sistema de coordenadas : como si giraramos toda la escena*/
    glPushMatrix();	/*Creamos una nueva matriz (la rotacion es desde el angulo 0)*/
    glRotated(rotation, 0, 1, 0);
    glMatrixMode(GL_MODELVIEW);

	/*Dibujamos en el buffer que no se ve(back) y cuando ya esta lo visualizamos en el que
	se ve(front)*/
    glDrawBuffer(GL_BACK);
	/*Antes de dibujar limpiamos el buffer de color y la memoria de profundidad*/
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);/*Limpiar el buffer de color y el
						de profundidad*/              
	/*Dibujamos el objeto*/
    dibuja_cilindro();

    glPopMatrix();
    
   // glutSwapBuffers(); /*Pasamos el buffer back delante:lo dejo en ondraw*/
	// Clear the window with current clearing color
//	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// Rotate
	//glRotatef(3.0f,0.0f, 0.0f, 1.0f); // Rock Z
	//glRotatef(3.0f,1.0f, 0.0f, 0.0f); // Roll X

	// Dibuja texto
/*	glListBase(1000);
	glPushMatrix();
	glCallLists (6, GL_UNSIGNED_BYTE, "PRUEBA"); //Dibuja texto
	glPopMatrix();*/

	//Dibujamos objetos
//	dibuja_cilindro();

	// Flush drawing commands
	glFlush();
}


/*******************************************************************
Utilizaremos una tira de triangulos para generar el cilindro
*********************************************************************/
static void dibuja_cilindro(void)
{
    int numSides = 20;
    double radius = 0.7;
    double stepSize = 2.0*PI / numSides;
    int i;

    GLfloat matAmbDiff1[4] = { 1.0f, 1.0f, 0.00f, 1.0f };
    GLfloat matAmbDiff2[4] = { 1.0f, 0.0f, 0.00f, 1.0f };

/*Material asignado*/

    if (mi_material==0)
       glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, matAmbDiff1);
    else
       glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, matAmbDiff2);

/*Lista de los vertices de la tira de triangulos. Hay que calcular tambien las normales
porque vamos a utilizar la iluminacion de opengl*/
    glBegin(GL_TRIANGLE_STRIP);
    for (i=0; i<=numSides; ++i) 
	{
		double a = i * stepSize;
		GLfloat x = (GLfloat)cos(a);
		GLfloat y = (GLfloat)sin(a);

		glNormal3f(x, y, 0.0);
		glColor4f(i*0.1f,0.2f,0.7f, 0.9f); /*INMA: PONER COLOR Y DESACTIVAR LA ILUMINACION*/
		glVertex3f((float)(x * radius),(float)( y * radius), 0.7f);
		glNormal3f(x, y, 0.0); /*No seria necesario, porque como es igual que el anterior,
				una vez enviado un vector no se cambia hasta que no se envia
				otroe nuevo*/
		glVertex3f((float)(x * radius),(float)( y * radius), -0.7f);
    }
    glEnd();
}


/***********************************************************
Funcion a la que llama el sistema cuando no tiene nada que hacer
Lo que hacemos es actualizar el angulo de giro segun el tiempo que 
ha transcurrido desde el ultimofotograma
DESDE DONDE LA LLAMO EN EL VISUAL???????
***********************************************************/
static void actualizar_giro(void)
{
/*	if (animacionActivada)
	{
		double currentTime = getTime(); //Miratiempo actual
		double elapsed = currentTime - lastTime; //Lo compara con el del ultimo/

		lastTime = currentTime;

		//Actualiza la rotacion segun el tiempo transcurrido
		//Si eltiempo transcurrido es muy grand??
		rotation += rotationRate * ((elapsed <= 1.0) ? elapsed : 1.0);
		if (rotation >= 360) rotation -= 360;

	//	glutPostRedisplay();
    }*/
    
}


/************************************************************
Funcion de callback del teclado
**************************************************************/
void teclado_pulsada(unsigned char key)
{
/*inma*/ static int mode=0;
    switch (key) 
	{
      case 'm': /*Cambiamos material*/
	  case 'M': 
		mi_material = (mi_material==0)? 1:0;
		//glutPostRedisplay(); /*Envia evento de redibujado despues de hacer un cambio*/
		break;
      case 'r': /*Cambiamos modo de rellenado de los poligonos: relleno*/
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		//glutPostRedisplay();
		break;
      case 'l': /*Pone en modo de lineas*/
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		//glutPostRedisplay();
		break;
      case 'a': /*Activa o desactiva la animacion*/
		animacionActivada = !animacionActivada;
		//glutPostRedisplay();
		break;
      case 'f': /*Cambia modo flat*/
		if(mode==0)
		{
			glShadeModel(GL_FLAT);
			mode=1;
		}
		else
		{
		  glShadeModel(GL_SMOOTH);
		 mode=0;	    
		}
		break;
  
     // case 27:
	//	exit(0);
    }
}
